#objective: use upto to generate an array of boxes, then use the component feature to further edit the group. 
require 'sketchup.rb'

def box4
    Sketchup::set_status_text("<<<<<< Create an array of Boxes: along XY Planes >>>>>", SB_PROMPT)
    $xyheight = 3.feet if not $xyheight 
    $xywidth = 3.feet if not $xywidth
    $xydepth = 3.feet if not $xydepth 
    $xynx = 3 if not $xynx
    $xyny = 3 if not $xyny
    $xydist = 4.inch if not $xydist
       
    prompts = ["Width", "Height", "Depth" ]
    values = [$xyheight, $xywidth, $xydepth]
    results = inputbox prompts, values, "Block Dimensions"
    $xywidth, $xyheight, $xydepth = results
#----------------------------------------------------    
    model = Sketchup.active_model
    model.start_operation "Create Boxes"
#---------------------------------------------------- 
    prompts = [ "No. of Blocks along X axis ", "No. of Blocks along Y axis ", "Distance btw. Blocks"]

    values = [$xynx, $xyny, $xydist]
    results = inputbox prompts, values, "Block Array Size"
    $xynx, $xyny, $xydist = results
    z=$xydist
    
    if ($xynx <= 0) then $xynx = 1
    end
    if ($xyny <= 0) then $xyny = 1
    end   
              definitions = model.definitions   # at this location the following 3 lines allows each component in the group 
              component = definitions.add       # to be individually changed. I'm STUCK now 
              entities = component.entities     # I want to make changes to only one component, and had have the other 8 follow those same changes.
           
       0.upto($xynx-1) do |i|                  # Number of blocks along X 
        x = ($xywidth*i)+(i*$xydist)
        
      
        0.upto($xyny-1) do |j|                 # Number of blocks along Y
          y = ($xyheight*j)+(j*$xydist)
          
            
                                         
              base = entities.add_face([x+$xydist, y+$xydist, z],
                                       [x+$xydist+$xywidth, y+$xydist, z],
                                       [x+$xydist+$xywidth, y+$xydist+$xyheight, z],
                                       [x+$xydist, y+$xydist+$xyheight, z]
                                       )
              base.pushpull $xydepth
                     
              trans = Geom::Transformation.new 
              Sketchup.active_model.active_entities.add_instance(component, trans) 
        end
      end
#---------------------------------------------------
    view = model.active_view.zoom_extents 
#---------------------------------------------------
    model.commit_operation
end

if( not file_loaded?("box4.rb") )
   add_separator_to_menu("Plugins")
   UI.menu("Plugins").add_item("Boxes along XY") { box4 }
end
#-----------------------------------------------------------------------------
file_loaded("box4.rb") #  load"box4.rb"
